/*rescaling functions*/
 
/***** 
TO DO: Make sure user hasn't dragged with zero width....probably just ignore zero
 width windows
******/ 
 
#include "stdmap.h"

extern PlotData plotSize;

void ReScale(double xmin, double xmax, double ymin, double ymax)
{	
	plotSize.xmax = xmax,plotSize.ymax = ymax;
	plotSize.xmin = xmin,plotSize.ymin = ymin;
	ortho2(plotSize.xmin,plotSize.xmax,plotSize.ymin,plotSize.ymax);
	EraseWindow();
	WriteTitle();
}

void DragScale(int flag)
{
    Rect DragRect;
    Point stPt, endPt;
    double thePt[2];
    double xmin,xmax,ymin,ymax;
    double scale,origin;
    Boolean change;
    
    GetMouse(&stPt);
    endPt = DragPoint(stPt,BOX);
    
    //allow user to do it in the wrong order
    SetRect(&DragRect, min(stPt.h,endPt.h),min(stPt.v,endPt.v),max(stPt.h,endPt.h),max(stPt.v,endPt.v));

    stPt.h = DragRect.left,  stPt.v = DragRect.bottom;
    endPt.h = DragRect.right,  endPt.v= DragRect.top;
   
	if(flag==1)
	{ 	    
		GlobalToLocal(stPt, thePt);
		xmin = thePt[0];
		ymin = thePt[1];
		GlobalToLocal(endPt, thePt);
		xmax = thePt[0];
		ymax = thePt[1];
	} else
	{
	//	GlobalToLocal(blcorner, thePt);
	//	origin = plotSize.xmin+ 0.5*(thePt[0];
	//	scale =  (double)(plot->portRect.left-plot->portRect.right)/(double)(DragRect.left-DragRect.right);
	//	xmin = scale*(plotSize.xmin-origin) + origin;
	//	xmax = scale*(plotSize.xmax-origin) + origin;
	//	origin = plotSize.ymax - 0.5*(DragRect.top+DragRect.bottom)/plotSize.dy;
	//	scale =  (double)(plot->portRect.bottom-plot->portRect.top)/(double)(DragRect.bottom-DragRect.top);
	//	ymin = scale*(plotSize.ymin-origin) + origin;
	//	ymax = scale*(plotSize.ymax-origin) + origin;
	}
	
	ReScale(xmin,xmax,ymin,ymax);
}

Point DragPoint(Point anchor, int type)		// drag a curve of 'type' from anchor
{															// until mouse released
    Point endPt, oldPt;										// returning the release point
    Boolean constrain;
    oldPt.h=oldPt.v=0;
    constrain = isPressed(SHIFT);							// shift down so constrain drawing	
    
   pushattributes();
   drawmode(OVERDRAW);
       oldPt = anchor;
	do
	{
	    GetMouse(&endPt);
	    if(constrain)
		    Constrain(type, &endPt,anchor);
		    
	    if(oldPt.h!=endPt.h || oldPt.v != endPt.v)  //only if mouse moved
	    {
		    color(0);
		    DrawCurve(type,anchor,oldPt);	    //erase old curve
		    color(1);
		    DrawCurve(type,anchor,endPt);	    //draw new curve
		    oldPt=endPt;			
	    }
	}while(getbutton(MIDDLEMOUSE));
	    
	color(0);
	DrawCurve(type,anchor,oldPt);		    //erase old curve
    drawmode(NORMALDRAW);
    popattributes();			
    return(endPt);
}

void DrawCurve(int curveType, Point stPt, Point endPt)
{
	Rect DragRect;
	
	SetRect(&DragRect, min(stPt.h,endPt.h),min(stPt.v,endPt.v),max(stPt.h,endPt.h),max(stPt.v,endPt.v));
	switch(curveType)
	{		
		default:
		case BOX:		
			FrameRect(&DragRect);
		break;
		case CIRCLE:
			//FrameOval(&DragRect);
		break;
		case LINE:
			//MoveTo(stPt.h, stPt.v);
			//LineTo(endPt.h,endPt.v);
		break;
	}
}

void Constrain(int curveType, Point *apt, Point bpt)  //make apt-bpt vertical, diagonal or horizontal only
{
	int dx,dy;
	dx = apt->h-bpt.h;
	dy = bpt.v-apt->v;
	if(curveType!=LINE)
		apt->v = bpt.v - abs(dx)*sign(dy);
	else if(abs(dx) < 0.5*abs(dy))
		apt->h = bpt.h;
	else if(abs(dx) > 2.0*abs(dy))
		apt->v = bpt.v;
	else 
		apt->v = bpt.v - abs(dx)*sign(dy);
}

void FrameRect(Rect *aRect)
{  
    double thePt[2], bl[2], tr[2];
    Point corner;
    corner.h=aRect->left,  corner.v=aRect->bottom;
    GlobalToLocal(corner, bl);
    corner.h=aRect->right,  corner.v=aRect->top;
    GlobalToLocal(corner, tr);    
    bgnclosedline();
	v2d(bl);
	thePt[0]=bl[0], thePt[1]=tr[1];
	v2d(thePt);
	v2d(tr);
	thePt[0]=tr[0], thePt[1]=bl[1];
	v2d(thePt);	
    endclosedline();        
}

void SetRect(Rect *aRect,  Screencoord l, Screencoord b,  Screencoord r,  Screencoord t)
{
    aRect->left = l;
    aRect->bottom = b;
    aRect->right = r;
    aRect->top = t;
}
