#include <math.h>
#include <gl.h>
#include <stdio.h>
#include <device.h>

#define ITMAX 25
#define ERRy 1.e-13
#define ERRv 1.e-9
#define MINIMIZE 0
#define MINIMAX 2
#define FIXS 2
#define FIXSR 3
#define FIXTS 4
#define FIXTSR 5


#define BOX 1
#define CIRCLE 2
#define LINE 3

#define SHIFT 0

typedef struct
{
	double x,y;
	long p,q;
	int type;
} Orbit;

typedef struct {
    Screencoord h;
    Screencoord v; 
}   Point;

typedef struct {
    Screencoord top, left, right, bottom;   
} Rect;

typedef struct
{
    Coord xmin, xmax, ymin, ymax;    
} PlotData;


#define min(a,b) ((a)>(b)?(b):(a))
#define max(a,b) ((a)>(b)?(a):(b))
#define sign(x) ((x)>0?(1):(-1))

/*Function prototypes*/

void initialize(void);
void HandleMenu(int item);
void PlotStd(double *thePt,long n);
void PlotHenon(double *thePt,long n);
void PlotRects(double *thePt,long n);
void EraseWindow(void);
void ZoomWindow();
void WriteTitle(void);

Orbit FindCantorus(void);
void FareyPath(Orbit,Orbit ,char*);
void DefOrbit( Orbit*,long,long,int);
int secant(Orbit*,double);
double HalfOrbit(double);
double Symmetry(double,int,long);

void ReScale(double xmin, double xmax, double ymin, double ymax);
void DragScale(int flag);
Point DragPoint(Point anchor, int type);
void DrawCurve(int curveType, Point stPt, Point endPt);
void Constrain(int curveType, Point *apt, Point bpt);
void FrameRect(Rect *aRect);
void SetRect(Rect *aRect,  Screencoord l, Screencoord b,  Screencoord r,  Screencoord t);

