/* Show xy position*/
#include "AP.h"
#include <stdio.h>

extern WindowPtr plot;
extern RGBColor WHITE, BLACK;
extern Boolean hasColor;

Rect posRect;
Point posPt;

void OpenPosition(Boolean flag)
{
	int b,r;
	
	SetPort(plot);
	if(flag)
	{
		TextFont(4);
		TextSize(9);
		b = plot->portRect.bottom;
		r = plot->portRect.right;
		SetRect(&posRect,r-100,b-11,r,b);
		posPt.h = r-98;
		posPt.v = b-2;
	} else
		InvalRect(&posRect);
}

void UpdatePosition()
{
	static Point oPt;
	static Str255 aStr;
	Point thePt;
	dPoint pos;

	SetPort(plot);
	GetMouse(&thePt);
	
	if(PtInRect(thePt,&(plot->portRect)) && (thePt.h != oPt.h || thePt.v != oPt.v))
	{
		oPt = thePt;
		pos = WindowToPhys(thePt);
		if(hasColor) 
		{
			RGBForeColor(&WHITE);
			PaintRect(&posRect);
			RGBForeColor(&BLACK);
		} else
			EraseRect(&posRect);
		sprintf((char*)aStr,"(%.3lg,%.3lg)",pos.x,pos.y);
		MoveTo(posPt.h,posPt.v);
		DrawString(CtoPstr((char*)aStr));
	}
}
